Package org.springframework.transaction

# Interface ReactiveTransactionManager

All Superinterfaces:
  `TransactionManager`

All Known Implementing Classes:
  `AbstractReactiveTransactionManager`

public interface ReactiveTransactionManager extends TransactionManager
This is the central interface in Spring's reactive transaction infrastructure. Applications can use this directly, but it is not primarily meant as an API: Typically, applications will work with either transactional operators or declarative transaction demarcation through AOP.

Since:
  5.2
Author:
  Mark Paluch, Juergen Hoeller
See Also:
  - `TransactionalOperator`
  - `TransactionInterceptor`
  - `PlatformTransactionManager`
  - `ConfigurableTransactionManager`

## Method Summary

Modifier and Type
Method
Description
`reactor.core.publisher.Mono<Void>`
`commit(ReactiveTransaction transaction)`
Commit the given transaction, with regard to its status.
`reactor.core.publisher.Mono<ReactiveTransaction>`
`getReactiveTransaction(TransactionDefinition definition)`
Emit a currently active reactive transaction or create a new one, according to the specified propagation behavior.
`reactor.core.publisher.Mono<Void>`
`rollback(ReactiveTransaction transaction)`
Perform a rollback of the given transaction.

## Method Details

### getReactiveTransaction

reactor.core.publisher.Mono<ReactiveTransaction> getReactiveTransaction(@Nullable TransactionDefinition definition)
Emit a currently active reactive transaction or create a new one, according to the specified propagation behavior.

Note that parameters like isolation level or timeout will only be applied to new transactions, and thus be ignored when participating in active ones.

Furthermore, not all transaction definition settings will be supported by every transaction manager: A proper transaction manager implementation should throw an exception when unsupported settings are encountered.

An exception to the above rule is the read-only flag, which should be ignored if no explicit read-only mode is supported. Essentially, the read-only flag is just a hint for potential optimization.

Note: In contrast to `PlatformTransactionManager`, exceptions are propagated through the reactive pipeline returned from this method.

Parameters:
  `definition` - the TransactionDefinition instance, describing propagation behavior, isolation level, timeout etc.
Returns:
  transaction status object representing the new or current transaction
Throws:
  `TransactionException` - in case of lookup, creation, or system errors
  `IllegalTransactionStateException` - if the given transaction definition cannot be executed (for example, if a currently active transaction is in conflict with the specified propagation behavior)
See Also:
  - `TransactionDefinition.getPropagationBehavior()`
  - `TransactionDefinition.getIsolationLevel()`
  - `TransactionDefinition.getTimeout()`
  - `TransactionDefinition.isReadOnly()`

### commit

reactor.core.publisher.Mono<Void> commit(ReactiveTransaction transaction)
Commit the given transaction, with regard to its status. If the transaction has been marked rollback-only programmatically, perform a rollback.

If the transaction wasn't a new one, omit the commit for proper participation in the surrounding transaction. If a previous transaction has been suspended to be able to create a new one, resume the previous transaction after committing the new one.

Note that when the commit call completes, no matter if normally or propagating an exception, the transaction must be fully completed and cleaned up. No rollback call should be expected in such a case.

Note: In contrast to `PlatformTransactionManager`, exceptions are propagated through the reactive pipeline returned from this method. Also, depending on the transaction manager implementation, `commit` may propagate `DataAccessException` as well.

Parameters:
  `transaction` - object returned by the `getTransaction` method
Throws:
  `UnexpectedRollbackException` - in case of an unexpected rollback that the transaction coordinator initiated
  `HeuristicCompletionException` - in case of a transaction failure caused by a heuristic decision on the side of the transaction coordinator
  `TransactionSystemException` - in case of commit or system errors (typically caused by fundamental resource failures)
  `IllegalTransactionStateException` - if the given transaction is already completed (that is, committed or rolled back)
See Also:
  - `TransactionExecution.setRollbackOnly()`

### rollback

reactor.core.publisher.Mono<Void> rollback(ReactiveTransaction transaction)
Perform a rollback of the given transaction.

If the transaction wasn't a new one, just set it rollback-only for proper participation in the surrounding transaction. If a previous transaction has been suspended to be able to create a new one, resume the previous transaction after rolling back the new one.

Do not call rollback on a transaction if commit failed. The transaction will already have been completed and cleaned up when commit returns, even in case of a commit exception. Consequently, a rollback call after commit failure will lead to an IllegalTransactionStateException.

Note: In contrast to `PlatformTransactionManager`, exceptions are propagated through the reactive pipeline returned from this method. Also, depending on the transaction manager implementation, `rollback` may propagate `DataAccessException` as well.

Parameters:
  `transaction` - object returned by the `getTransaction` method
Throws:
  `TransactionSystemException` - in case of rollback or system errors (typically caused by fundamental resource failures)
  `IllegalTransactionStateException` - if the given transaction is already completed (that is, committed or rolled back)